/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi> */

#ifndef _IRC_H_
#define _IRC_H_

#include <glib.h>

/* these may be moved to the actual .c file as they're not really
 * supposed to be called elsewhere. i_alloc_irc_user needs a public
 * wrapper such as i_new_user() */
extern irc_user *i_alloc_irc_user(void);

/* send_* functions send data to network, other users etc. _globops
 * and _privmsg send the stuff from services, the rest use the
 * provided irc_user struct. */
extern void i_send_nick(irc_user *);
extern void i_send_sjoin(irc_user *, char *);
extern void i_send_part(irc_user *user, char *);
extern void i_send_quit(irc_user *, char *);
extern void i_send_globops(char *, ...);
extern void i_send_notice(irc_user *, char *, ...);
extern void i_send_privmsg(char *, char *, ...);
extern void i_send_whois(irc_user *, irc_user *, GString *);

extern void i_autokill_user(irc_user *, int, char *);
extern void i_kill_user(irc_user *, char *);

/* parse functions, don't call these directly. server.c parse_line()
 * functions feeds the handlers which call these. */
extern void i_parse_stats(irc_msg *);
extern void i_parse_version(irc_msg *);
extern void i_parse_info(irc_msg *);
extern void i_parse_nick(irc_msg *);
extern void i_parse_quit(irc_msg *);
extern void i_parse_kick(irc_msg *);
extern void i_parse_ping(irc_msg *);
extern void i_parse_invite(irc_msg *);
extern void i_parse_motd(irc_msg *);
extern void i_parse_privmsg(irc_msg *);
extern void i_parse_admin(irc_msg *);
extern void i_parse_whois(irc_msg *);
extern void i_parse_lusers(irc_msg *);
extern void i_parse_mode(irc_msg *);
extern void i_parse_kill(irc_msg *);
extern void i_parse_svsmode(irc_msg *);

extern void s_parse_channel_mode(char *, char **, int);

/* weird fj stuff. */
void foreach_motd_line(gpointer, gpointer);

#endif /* _IRC_H_ */

