/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi> */

#ifndef _MAGIC_H_
#define _MAGIC_H_

#define SPAMSTR_KILL    0x01
#define SPAMSTR_AKILL   0x02
#define SPAMSTR_REPORT  0x04
#define SPAMSTR_CHANNEL 0x08
#define SPAMSTR_SHOWINFO 0x10
#define SPAMSTR_DEFAULT (SPAMSTR_REPORT)

#define USE_AUTOKILL(x) ((x)->flags & (SPAMSTR_AKILL))
#define USE_KILL(x) ((x)->flags  & (SPAMSTR_KILL))
#define USE_REPORT(x) ((x)->flags & (SPAMSTR_REPORT))
#define CHECK_CHANNELS(x) ((x)->flags & (SPAMSTR_CHANNEL))
#define SHOW_INFO(x) ((x) & (SPAMSTR_SHOWINFO))


void spam_str_do_spamchecks(irc_msg *msg);
void spam_str_clean_all(void);


struct spam_str *spam_str_find(char *);
struct spam_str *spam_str_find_by_id(unsigned int);
int spam_str_add(char *, const char *, time_t, int, unsigned long,
	         unsigned long, time_t,	gboolean, unsigned long *);
int spam_str_add_reason_by_id(unsigned long, const char *);
int spam_str_add_reason(struct spam_str *, const char *);
int spam_str_add_comment_by_id(unsigned long id, const char *comment);
int spam_str_add_comment(struct spam_str *str, const char *comment);
int spam_str_del_id(unsigned long);
void spam_str_list_to(irc_user *, int, char *);

#endif	/* _MAGIC_H_ */
