/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi>
 *
 * Parts written by FJ (David). Based on the original work by Pasi Hirvonen
 * and Matthew Stephenson. Various others have contributed ideas and testing.*/

/* $Id: motd.c 150 2004-05-24 23:52:35Z pasi $ */

#include <glib.h>
#include <stdio.h>
#include <strings.h>
#include <string.h>

#include "spamserv.h"
#include "motd.h"

GSList *gsmotd = NULL;

GSList *s_cache_motd()
{
	FILE *fp;
	char buffer[4096];
	
	if (gsmotd != NULL)
		return gsmotd;
	fp = fopen(MOTDFILE, "r");
	if (fp != NULL) {
		while (fgets(buffer, sizeof(buffer), fp))
			motd_addline(buffer);
		fclose(fp);
	} else {
		gsmotd = g_slist_append(gsmotd, g_strdup("No MOTD has been set."));
	}
	return gsmotd;
}

/* this mess is required in order to split upon a space (' ' -> \n) at <=90 chars */
GSList *motd_addline(char *line)
{
	char *c, *buffer;
	
	c = index(line, '\n');
	if (c != NULL)
		c[0] = '\0';
	c = index(line, '\r');
	if (c != NULL)
		c[0] = '\0';
	buffer = g_strdup(line);
	while (strlen(buffer) > 90) {
		for (c = buffer+90; c != buffer; c--) {
			if (c[0] == ' ') {
				c[0] = '\0';
				gsmotd = g_slist_append(gsmotd, buffer);
				buffer = g_strdup(&c[1]);
				break;
			}
		}
	}
	gsmotd = g_slist_append(gsmotd, buffer);
	return gsmotd;
}
